<!DOCTYPE html>
<html>
<head>
  <meta charset="UTF-8">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>
<body>
  <div class="container mt-4">
    <h2>Lucky Dice History</h2>
      <div class="form-group">
        <label for="username">User name:</label>
        <input type="email" class="form-control" id="input-username" placeholder="Enter username" name="username">
      </div>
      <div class="form-group">
        <button type="button" class="btn btn-primary" onclick="onBtnPrizeHistoryClick()">Show Prize History Table</button>
      </div>
    <div id="log-result" class="mt-5"></div>
    <div class="mt-5">
      <table id="table-prize-history" class="table table-striped table-bordered table-hover">
        <thead>
          <tr>
            <th>Game</th>
            <th>Prize</th>
          </tr>
        </thead>
        <tbody>
          
        </tbody>
      </table>
    </div>
  </div>

  <script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gEND_OF_ROW_COL = -1;
    const gCOLUMN_GAME = 0;
    const gCOLUMN_PRIZE = 1;
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //ham xu ly su kien
    function onBtnPrizeHistoryClick(){
      var vUserObj = {
        username:""
      };
      //b1 thu thap du lieu
      thuThapDuLieu(vUserObj);
      //b2 validate du lieu
      var vDuLieuHopLe = kiemTraDuLieu(vUserObj);
      if(vDuLieuHopLe){
        var vXmlHttpPrizeHistory = new XMLHttpRequest();
        //b3 goi api de lay lich su phan thuong
        goiApiLayLichSuPrize(vUserObj,vXmlHttpPrizeHistory);
        //b4 hien thi lich su phan thuong len table
        vXmlHttpPrizeHistory.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                  hienThiLichSuPrize(vXmlHttpPrizeHistory);      
                }
            }
      }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function thuThapDuLieu(paramUserObj){
      var vUserNameInput = document.getElementById("input-username");
      paramUserObj.username = vUserNameInput.value.trim();
    }

    function kiemTraDuLieu(paramUserObj){
      if(paramUserObj.username == ""){
        alert("Ban can nhap vao username!");
        return false;
      }
      return true;
    }

    function goiApiLayLichSuPrize(paramUserObj,paramXmlHttp){
      paramXmlHttp.open("GET", gBASE_URL + "/prize-history?username=" + paramUserObj.username, true);
      paramXmlHttp.send();
    }

    function hienThiLichSuPrize(paramXmlHttp){
      console.log(paramXmlHttp.responseText);
      var vPrizeHistoryObj = JSON.parse(paramXmlHttp.responseText);
      var vPrizeHistoryTable = document.getElementById("table-prize-history");
      for(var bI=0; bI< vPrizeHistoryObj.prizes.length;bI++){
        //them 1 dong moi
        var bNewRow = vPrizeHistoryTable.insertRow(gEND_OF_ROW_COL);
        //them 2 o tren dong
        var bGameCell = bNewRow.insertCell(gCOLUMN_GAME);
        var bPrizeCell = bNewRow.insertCell(gCOLUMN_PRIZE);
        //dien du lieu vao tung o
        bGameCell.innerHTML = bI + 1;
        bPrizeCell.innerHTML = vPrizeHistoryObj.prizes[bI];
      }

    }
  </script>


</body>

</html>